## pymvpa2 2.2.0

=== Makefile ===
PROFILE_FILE=$(CURDIR)/$(BUILDDIR)/main.pstats
COVERAGE_REPORT=$(CURDIR)/$(BUILDDIR)/coverage
BUILDDIR=$(CURDIR)/build
BUILD3DIR=$(CURDIR)/build/py3k
HTML_DIR=$(BUILDDIR)/html
DOC_DIR=$(CURDIR)/doc
TUT_DIR=$(CURDIR)/datadb/tutorial_data/tutorial_data
DOCSRC_DIR=$(DOC_DIR)/source
DOCBUILD_DIR=$(BUILDDIR)/doc
NOTEBOOKBUILD_DIR=$(HTML_DIR)/notebooks
MAN_DIR=$(BUILDDIR)/man
APIDOC_DIR=$(HTML_DIR)/api
PDF_DIR=$(BUILDDIR)/pdf
LATEX_DIR=$(BUILDDIR)/latex
WWW_DIR=$(BUILDDIR)/website
SWARM_DIR=$(BUILDDIR)/swarm
WWW_UPLOAD_URI=www.pymvpa.org:/home/www/www.pymvpa.org/pymvpa
WWW_UPLOAD_URI_DEV=dev.pymvpa.org:/home/www/dev.pymvpa.org/pymvpa
DATA_UPLOAD_URI=data.pymvpa.org:/home/www/data.pymvpa.org/www/datasets
DATA_URI=data.pymvpa.org::datadb
SWARMTOOL_DIR=tools/codeswarm
SWARMTOOL_DIRFULL=$(CURDIR)/$(SWARMTOOL_DIR)
RSYNC_OPTS=-az -H --no-perms --no-owner --verbose --progress --no-g --exclude prev/
RSYNC_OPTS_UP=-rzlhv --delete
# -p --chmod=Dg+s,g+rw,o+rX

#
# The Python executable to be used
#
PYTHON = python
PYTHON3 = python3

# Setup local PYTHONPATH depending on the version of provided $(PYTHON)
PYVER = $(shell $(PYTHON) -c 'import sys; print(sys.version_info[0])')
ifeq ($(PYVER),2)
 # just use the local sources and run tests 'in source'
 TEST_DIR = .
 LPYTHONPATH = .:$(PYTHONPATH)
else
 # for 3 (and hopefully not above ;) ) -- corresponding build/
 # since sources go through 2to3 conversion
 TEST_DIR = $(BUILD3DIR)
 LPYTHONPATH = $(BUILD3DIR):$(PYTHONPATH)
endif

# Assure non-interactive Matplotlib and provide local paths helper
MPLPYTHONPATH = PYTHONPATH=.:$(LPYTHONPATH) MVPA_MATPLOTLIB_BACKEND=agg
MPLPYTHON = $(MPLPYTHONPATH) $(PYTHON)
MPLPYTHON3 = $(MPLPYTHONPATH) $(PYTHON3)

NOSETESTS = $(PYTHON) $(shell which nosetests)

#
# Helpers for version handling.
# Note: can't be ':='-ed since location of invocation might vary
DEBCHANGELOG_VERSION = $(shell dpkg-parsechangelog | egrep ^Version | cut -d ' ' -f 2,2 | cut -d '-' -f 1,1)
SETUPPY_VERSION = $(shell $(PYTHON) setup.py -V)

#
# Automatic development version
#
#yields: LastTagName_CommitsSinceThat_AbbrvHash
DEV_VERSION := $(shell git describe --abbrev=4 HEAD |sed -e 's/-/+/g' |cut -d '/' -f 2,2)

# By default we are releasing with setup.py version
RELEASE_VERSION ?= $(SETUPPY_VERSION)
RELEASE_CODE ?=

# Conditional depends regulated from outside
#
ifdef PYMVPA_NO_3RD
	build_depends :=
else
	build_depends :=
endif

#
# Details on the Python/system
#

PYVER := $(shell $(PYTHON) -V 2>&1 | cut -d ' ' -f 2,2 | cut -d '.' -f 1,2)

#
# Little helpers
#

mkdir-%:
	if [ ! -d $($*) ]; then mkdir -p $($*); fi


#
# Building
#

all: build

# build included 3rd party pieces (if present)
3rd: 3rd-stamp
3rd-stamp:
	find 3rd -mindepth 1 -maxdepth 1  -type d | \
	 while read d; do \
	  [ -f "$$d/Makefile" ] && $(MAKE) -C "$$d" || :; \
     done
	touch $@


debian-build:
# reuse is better than duplication (yoh)
	debian/rules build


build: build-stamp
build-stamp: $(build_depends)
	$(PYTHON) setup.py config --noisy
	$(PYTHON) setup.py build_ext --inplace
	touch $@

build3: build3-stamp
build3-stamp: $(build_depends)
	$(PYTHON3) setup.py config --noisy
	$(PYTHON3) setup.py build_ext --inplace
	touch $@

#
# Cleaning
#

# this target is used to clean things for a fresh build
clean:
	@echo "I: Performing clean operation"
# clean 3rd party pieces
	find 3rd -mindepth 1 -maxdepth 1  -type d | \
	 while read d; do \
	  [ -f "$$d/Makefile" ] && $(MAKE) -C "$$d" clean || : ; \
     done
# clean tools
	$(MAKE) -C tools clean
# clean pics
	$(MAKE) -C doc/pics clean
# clean docs
	$(MAKE) -C doc clean
	-@rm -f $(DOCSRC_DIR)/examples/*.rst
# clean all bits and pieces
	-@rm -f MANIFEST
	-@rm -f mvpa2/clfs/lib*/*.so \
		mvpa2/clfs/lib*/*.dylib \
		mvpa2/clfs/lib*/*_wrap.* \
		mvpa2/clfs/lib*/*c.py \
		mvpa2/tests/*.{prof,pstats,kcache}
	@find . -name '*.py[co]' \
		 -o -name '*,cover' \
		 -o -name '.coverage' \
		 -o -name 'iterate.dat' \
		 -o -iname '*~' \
		 -o -iname '*.kcache' \
		 -o -iname '*.gch' \
		 -o -iname '*_flymake.*' \
		 -o -iname '#*#' | xargs -L 10 rm -f
	-@rm -rf build
	-@rm -rf dist *report __pycache__
	-@rm -f *-stamp *_report.pdf *_report.log pymvpa2.cfg

# this target should put the source tree into shape for building the source
# distribution
distclean: clean
# if we are on debian system - we might have left-overs from build
	-@$(MAKE) debian-clean
	-@rm -rf tools/codeswarm



debian-clean:
# remove stamps for builds since state is not really built any longer
	-fakeroot debian/rules clean


#
# Documentation
#

doc: website manpages

pics:
	$(MAKE) -C doc/pics

manpages: mkdir-MAN_DIR
	@echo "I: Creating manpages"
	PYTHONPATH=$(LPYTHONPATH) help2man -N -n 'preprocess fMRI data for PyMVPA' \
		bin/pymvpa2-prep-fmri > $(MAN_DIR)/pymvpa2-prep-fmri.1
	PYTHONPATH=$(LPYTHONPATH) help2man -N -n 'query stereotaxic atlases' \
		bin/pymvpa2-atlaslabeler > $(MAN_DIR)/pymvpa2-atlaslabeler.1
	PYTHONPATH=$(LPYTHONPATH) help2man -N -n 'start a PyMVPA tutorial session' \
		bin/pymvpa2-tutorial > $(MAN_DIR)/pymvpa2-tutorial.1

references:
	@echo "I: Generating references"
	tools/bib2rst_ref.py

# Since mpl doesn't take env variables
mpl-stamp: build
	echo "backend : Agg" >| $(CURDIR)/build/matplotlibrc
	touch $@

htmldoc: examples2rst build pics mpl-stamp tutorial2notebooks
	@echo "I: Creating an HTML version of documentation"
	cd $(DOC_DIR) && MVPA_EXTERNALS_RAISE_EXCEPTION=off \
		PYTHONPATH=$(CURDIR):$(PYTHONPATH) \
		MPLCONFIGDIR=$(CURDIR)/build HOME=$(CURDIR)/build \
		$(MAKE) html BUILDDIR=$(BUILDDIR) SPHINXOPTS="$(SPHINXOPTS)"
	cd $(HTML_DIR)/generated && ln -sf ../_static
	cd $(HTML_DIR)/examples && ln -sf ../_static
	cd $(HTML_DIR)/workshops && ln -sf ../_static
	cd $(HTML_DIR)/datadb && ln -sf ../_static
	cp $(DOCSRC_DIR)/pics/history_splash.png $(HTML_DIR)/_images/

pdfdoc: examples2rst build pics pdfdoc-stamp
pdfdoc-stamp: mpl-stamp
	@echo "I: Creating a PDF version of documentation"
	cd $(DOC_DIR) && MVPA_EXTERNALS_RAISE_EXCEPTION=off \
		PYTHONPATH=$(CURDIR):$(PYTHONPATH) \
		MPLCONFIGDIR=$(CURDIR)/build HOME=$(CURDIR)/build \
		$(MAKE) latex BUILDDIR=$(BUILDDIR) SPHINXOPTS="$(SPHINXOPTS)"
	cd $(LATEX_DIR) && $(MAKE) all-pdf
	touch $@

# Create a handy .pdf of the manual to be printed as a book
handbook: pdfdoc
	@echo "I: Creating a handbook of the manual"
	cd tools && $(MAKE) pdfbook
	build/tools/pdfbook -2 \
	 $(LATEX_DIR)/PyMVPA-Manual.pdf $(LATEX_DIR)/PyMVPA-Manual-Handbook.pdf

examples2rst: examples2rst-stamp
examples2rst-stamp: mkdir-DOCBUILD_DIR
	tools/ex2rst \
		--project PyMVPA \
		--outdir $(DOCSRC_DIR)/examples \
		--exclude doc/examples/searchlight_app.py \
		doc/examples
	touch $@

tutorial2notebooks: tutorial2notebooks-stamp
tutorial2notebooks-stamp:
	mkdir -p $(NOTEBOOKBUILD_DIR)
	tools/rst2ipnbpy \
		--baseurl http://pymvpa.org \
		--apiref_baseurl http://pymvpa.org/generated \
		--glossary_baseurl http://pymvpa.org/glossary.html \
		--outdir $(NOTEBOOKBUILD_DIR) \
		--exclude doc/source/tutorial_prerequisites.rst \
		--verbose \
		doc/source/tutorial_*.rst
	touch $@

apidoc: apidoc-stamp
apidoc-stamp: build
# Disabled profiling for now, it consumes huge amounts of memory, so I doubt
# that all buildds can do it. In theory it would only be done on a single
# developer machine, because it is only necessary for the arch-all package,
# but e.g. dpkg-buildpackage runs the indep target anyway -- not sure about
# the buildds, though.
#apidoc-stamp: profile
	@echo "I: Creating an API documentation with epydoc"
	mkdir -p $(HTML_DIR)/api
	LC_ALL=C MVPA_EPYDOC_WARNINGS=once tools/epydoc --config doc/api/epydoc.conf
	touch $@

# this takes some minutes !!
# TODO: adjust for py3 compatibility
profile: build mvpa2/tests/__init__.py
	@echo "I: Profiling unittests"
	@PYTHONPATH=$(LPYTHONPATH) tools/profile -K  -O $(PROFILE_FILE) mvpa2/tests/__init__.py


#
# Website
#

website: website-stamp
website-stamp: mkdir-WWW_DIR htmldoc pdfdoc
	cp -r $(HTML_DIR)/* $(WWW_DIR)
	cp $(LATEX_DIR)/PyMVPA-*.pdf $(WWW_DIR)
	tools/sitemap.sh > $(WWW_DIR)/sitemap.xml
# main icon of the website
	cp $(DOCSRC_DIR)/pics/favicon.png $(WWW_DIR)/_images/
# for those who do not care about <link> and just trying to download it
	cp $(DOCSRC_DIR)/pics/favicon.png $(WWW_DIR)/favicon.ico
# provide robots.txt to minimize unnecessary traffic
	cp $(DOCSRC_DIR)/_static/robots.txt $(WWW_DIR)/
# provide promised pylintrc
	mkdir -p $(WWW_DIR)/misc && cp $(DOC_DIR)/misc/pylintrc $(WWW_DIR)/misc
	touch $@

upload-website:
	$(MAKE) website SPHINXOPTS='-D html_theme=pymvpa_online'
	rsync $(RSYNC_OPTS_UP) $(WWW_DIR)/* $(WWW_UPLOAD_URI)/
	git update-ref refs/heads/website-updates/www HEAD

upload-htmldoc:
	$(MAKE) htmldoc SPHINXOPTS='-D html_theme=pymvpa_online'
	chmod a+rX -R $(HTML_DIR)
	rsync $(RSYNC_OPTS_UP) $(HTML_DIR)/* $(WWW_UPLOAD_URI)/
	git update-ref refs/heads/website-updates/www-html HEAD

upload-website-dev:
	sed -i -e "s,http://disqus.com/forums/pymvpa/,http://disqus.com/forums/pymvpa-dev/,g" \
		-e "s,^<!-- HEADNOTES -->,<!-- HEADNOTES --><div class='admonition note'>This content refers to an unreleased development version of PyMVPA</div>,g" \
		doc/source/_themes/pymvpa_online/page.html
	$(MAKE) website SPHINXOPTS='-D html_theme=pymvpa_online'
	sed -i -e "s,http://disqus.com/forums/pymvpa-dev/,http://disqus.com/forums/pymvpa/,g" \
		-e "s,^<!-- HEADNOTES -->.*$$,<!-- HEADNOTES -->,g" \
		doc/source/_themes/pymvpa_online/page.html
	sed -i -e "s,www.pymvpa.org,dev.pymvpa.org,g" $(WWW_DIR)/sitemap.xml
	chmod a+rX -R $(WWW_DIR)
	rsync $(RSYNC_OPTS_UP) $(WWW_DIR)/* $(WWW_UPLOAD_URI_DEV)/

upload-htmldoc-dev:
	grep -q pymvpa-dev doc/source/_themes/pymvpa_online/page.html || \
	 sed -i -e "s,http://disqus.com/forums/pymvpa/,http://disqus.com/forums/pymvpa-dev/,g" \
		-e "s,^<!-- HEADNOTES -->,<!-- HEADNOTES --><div class='admonition note'>This content refers to an unreleased development version of PyMVPA</div>,g" \
		doc/source/_themes/pymvpa_online/page.html
	$(MAKE) htmldoc SPHINXOPTS='-D html_theme=pymvpa_online'
	sed -i -e "s,http://disqus.com/forums/pymvpa-dev/,http://disqus.com/forums/pymvpa/,g" \
		-e "s,^<!-- HEADNOTES -->.*$$,<!-- HEADNOTES -->,g" \
		doc/source/_themes/pymvpa_online/page.html
	rsync $(RSYNC_OPTS_UP) $(HTML_DIR)/* $(WWW_UPLOAD_URI_DEV)/


# upload plain .rst files as descriptions to data.pympa.org as descriptions of
# each dataset
upload-datadb-descriptions:
	for ds in doc/source/datadb/*; do \
		ds=$$(basename $${ds}); ds=$${ds%*.rst}; \
		scp doc/source/datadb/$${ds}.rst $(DATA_UPLOAD_URI)/$${ds}/README.rst; \
	done

#
# Tests (unittests, docs, examples)
#

ut-%: build
	@cd $(TEST_DIR) && PYTHONPATH=$(LPYTHONPATH) $(NOSETESTS) --nocapture mvpa2/tests/test_$*.py

unittest: build
	@echo "I: Running unittests (without optimization nor debug output)"
	@cd $(TEST_DIR) && $(MPLPYTHON) mvpa2/tests/__init__.py


# test if PyMVPA is working if optional externals are missing
unittest-badexternals: build
	@echo "I: Running unittests under assumption of missing optional externals."
	@cd $(TEST_DIR) && PYTHONPATH=mvpa2/tests/badexternals:$(LPYTHONPATH) \
		MVPA_MATPLOTLIB_BACKEND=agg \
		$(PYTHON) mvpa2/tests/__init__.py 2>&1 \
		| grep -v -e 'WARNING: Known dependency' -e 'Please note: w' \
		          -e 'WARNING:.*SMLR.* implementation'

# only non-labile tests
unittest-nonlabile: build
	@echo "I: Running only non labile unittests. None of them should ever fail."
	@cd $(TEST_DIR) && MVPA_TESTS_LABILE=no \
		$(MPLPYTHON) mvpa2/tests/__init__.py

unittest-py3: build3
	@echo "I: Running py3-compatible unittests. None of them should ever fail."
	-@rm -f build3-stamp	# evil Tiziano! ;)
	@cd $(BUILD3DIR) && MVPA_TESTS_LABILE=no MVPA_TESTS_QUICK=yes \
		MVPA_TESTS_LOWMEM=yes $(MPLPYTHON3) mvpa2/tests/__init__.py

unittest-py3warn: build
	@echo "I: Running unittests with py3 warnings. None of them should ever fail."
	@MVPA_TESTS_LABILE=no MVPA_TESTS_QUICK=yes \
		MVPA_TESTS_LOWMEM=yes $(MPLPYTHON) -3 mvpa2/tests/__init__.py

=== debian/changelog ===
pymvpa2 (2.2.0-4ubuntu2) trusty; urgency=medium

  * debian/patches/python3_test_support.diff: added to update a test for
    python3

 -- Brian Murray <brian@ubuntu.com>  Fri, 21 Feb 2014 11:25:51 -0800

pymvpa2 (2.2.0-4ubuntu1) trusty; urgency=medium

  * Don't lookup sphinx extensions in /usr/share/pyshared.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 12 Feb 2014 17:03:27 +0100

pymvpa2 (2.2.0-4) unstable; urgency=low

  * debian/control:
    - specify git branch for debian packaging of pymvpa2. Thanks Julien
      Cristau for the report
    - build-depends on python-numpydoc
    - recommend python-pprocess (removed from the Debian archive since we
      missed a dependency on it and otherwise was unused, but is present
      from NeuroDebian )
    - policy boosted to 3.9.5 (no changes)
  * debian/rules:
    - mkdir target -lib directories before moving .so files.  It should resolve
      FTBFS with debhelper 9.20130507 and robustify build
    - quote paths with globs to avoid their expansion in find command.
      Thanks Julien Cristau for the hint

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 12 Dec 2013 08:55:02 -0500

pymvpa2 (2.2.0-3) unstable; urgency=low

  * debian/patches
    - changeset_bab55a4a390c9c4b337ead5877868f7f7debc208.diff
      Tollerate "Probabalistic" (mention the typo) and "fixed"
      FSL atlases

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 06 May 2013 15:02:58 -0400

pymvpa2 (2.2.0-2) unstable; urgency=low

  * debian/patches
    - changeset_79bc8ecad13fe43447f8a262ed03147cbe7da326.diff
      changeset_cdba16f73f5aa74cf3002f027a1d38e408b0361b.diff
      Address numpy 1.7.1 compatibility in unittests

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 30 Apr 2013 11:35:24 -0400

pymvpa2 (2.2.0-1) unstable; urgency=low

  * Fresh upstream release:
    - provides tutorial (in -doc package) as ipython notebooks.
      Added ipython-notebook into Suggests
    - all cmdline tools have disambiguating prefix thus are
      installed now without conflict with pymvpa (0.4.x) package.
  * Dropping support of python 2.5 (failing tests) -- added X-Python-Version

 -- Yaroslav Halchenko <debian@onerussian.com>  Sun, 16 Sep 2012 06:23:51 -0400

=== debian/control ===
Source: pymvpa2
Section: python
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: NeuroDebian team <team@neuro.debian.net>
Uploaders: Michael Hanke <mih@debian.org>, Yaroslav Halchenko <debian@onerussian.com>
Build-Depends: debhelper (>= 7.0.50~),
               python-all-dev (>= 2.4), python-support (>= 0.6), swig,
               python-numpy, python-scipy,
               python-nibabel,
               python-nose,
               python-h5py,
               python-lxml,
               libsvm-dev (>= 2.84.0),
               help2man,
               python-sphinx, python-numpydoc,
               graphviz, inkscape, imagemagick, bc,
Standards-Version: 3.9.5
Homepage: http://www.pymvpa.org
Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/pymvpa.git
Vcs-Git: git://git.debian.org/git/pkg-exppsy/pymvpa.git -b dist2/debian/proper/sid
X-Python-Version: >= 2.6


Package: python-mvpa2
Architecture: all
Depends: ${misc:Depends}, ${python:Depends},
         python-mvpa2-lib(>= ${source:Version}),
         python-numpy,
Recommends:
         python-h5py,
         python-lxml,
         python-matplotlib,
         python-mdp,
         python-nibabel,
         python-psutil,
         python-psyco,
         python-pywt,
         python-reportlab,
         python-scipy,
         python-sklearn,
         shogun-python-modular,
         liblapack-dev,
         python-pprocess,
Suggests:
         fslview, fsl,
         python-mvpa2-doc,
         python-nose,
         python-openopt,
         python-rpy2,
Provides: ${python:Provides}
XB-Python-Version: ${python:Versions}
Description: multivariate pattern analysis with Python v. 2
 PyMVPA eases pattern classification analyses of large datasets, with an
 accent on neuroimaging. It provides high-level abstraction of typical
 processing steps (e.g. data preparation, classification, feature selection,
 generalization testing), a number of implementations of some popular
 algorithms (e.g. kNN, Ridge Regressions, Sparse Multinomial Logistic
 Regression), and bindings to external machine learning libraries (libsvm,
 shogun).
 .
 While it is not limited to neuroimaging data (e.g. fMRI, or EEG) it
 is eminently suited for such datasets.
 .
 This is a package of PyMVPA v.2.  Previously released stable version
 is provided by the python-mvpa package.


Package: python-mvpa2-lib
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends},
         python-numpy
Provides: ${python:Provides}
XB-Python-Version: ${python:Versions}
Description: low-level implementations and bindings for PyMVPA v. 2
 This is an add-on package for the PyMVPA framework. It provides a low-level
 implementation of an SMLR classifier and custom Python bindings for the LIBSVM
 library.
 .
 This is a package of a development snapshot. The latest released version is
 provided by the python-mvpa-lib package.


Package: python-mvpa2-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, libjs-jquery, libjs-underscore
Suggests: python-mvpa2, python-mvpa2-tutorialdata, ipython-notebook
Description: documentation and examples for PyMVPA v. 2
 This is an add-on package for the PyMVPA framework. It provides a
 HTML documentation (tutorial, FAQ etc.), and example scripts.
 In addition the PyMVPA tutorial is also provided as IPython notebooks.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

srcpkg = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Source:' | cut -d ' ' -f 2,2)
debver = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Version:' | cut -d ' ' -f 2,2 )
upstreamver = $(shell echo $(debver) | sed -e 's/-[^-]*$$//' )

# this figures out the last merge point from 'master' into the 'dist' branch and
# then described this commit relative to the last release tag (upstream/...)
# If this should make any sense the local master branch must track remote
# master.
gitver = $(shell [ -x /usr/bin/git ] && git describe --tags --match 'upstream/*' $$(git merge-base -a HEAD master) | sed -e 's,^upstream/,,' -e 's/\.dev/~dev/' -e 's/\.rc/~rc/')

export HOME=$(CURDIR)/build

# one ring to rule them all ...
%:
# need to enforce distutils, since we also have a makefile
	dh $@ --buildsystem=python_distutils --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure
	mkdir -p $(CURDIR)/build

override_dh_auto_build:
	dh_auto_build -- --with-libsvm
	$(MAKE) manpages
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) htmldoc
	-rm build/html/_static/jquery.js build/html/_static/underscore.js
	$(MAKE) tutorial2notebooks
endif


# we run the test suite on the install
override_dh_auto_test:
	: # Tests will be ran later on against installed version

override_dh_auto_install:
	dh_auto_install -- --with-libsvm
	# run unit tests here to actually check the deployed package
	# whenever we don't have to build for python 2.5 anymore call
	# python with -B and remove the find for pyc files
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	for buildver in $(shell pyversions -vr); do \
		echo "I: Running PyMVPA unittests using python$$buildver"; \
		cd $(CURDIR)/debian/tmp/usr/lib/python$$buildver/*-packages && \
		PYTHONPATH=. MVPA_TESTS_LABILE=no MVPA_TESTS_LOWMEM=yes \
		MVPA_TESTS_QUICK=yes MVPA_TESTS_VERBOSITY=3 \
		python$$buildver mvpa2/tests/__init__.py \
		|| exit 1 ; find . -type f -name '*.pyc' -delete ; \
	done
endif
	# and now move libraries into -lib package (account for snapshot name
	# as well)
	mkdir -p $(CURDIR)/debian/python-mvpa2-lib
	cd $(CURDIR)/debian/python-mvpa2-lib && \
		for so in $$(find ../tmp -name '*.so'); do \
			install -D $$so $${so#../tmp/*} ; \
			rm $$so ; \
		done
	: # Do not install some existing scripts yet for now
	find debian -wholename '*/bin/*' -o -wholename '*/man/*' \
	| grep -e 'pymvpa2-\(analysis\)' \
	| xargs -r rm -rf

override_dh_pysupport:
	dh_pysupport
	if [ -x /usr/bin/dh_numpy ]; then dh_numpy; fi

override_dh_installchangelogs:
	dh_installchangelogs Changelog

override_dh_auto_clean:
	$(MAKE) clean
	dh_auto_clean
	-rm -rf $(CURDIR)/build

# make orig tarball from repository content
get-orig-source:
	# orig tarball, turn directory into something nicer
	git archive --format=tar --prefix=$(srcpkg)-$(gitver)/ HEAD | \
		tar --delete $(srcpkg)-$(gitver)/debian | \
		gzip -9 > $(srcpkg)_$(gitver).orig.tar.gz

# same for dev snapshots, but here it produces a dev changelog entry first
# that converts the source package name to -snapshot
dev-source: dev-changelog get-orig-source
	mv $(srcpkg)_$(gitver).orig.tar.gz ..

# helper to create a new changelog entry for a development snapshot package
# go with default changelog item for each new snapshot, but fire up editor
# if there already was a changelog for this upstream version, as there is
# probably something to say about this new Debian snapshot package release
dev-changelog:
	@if [ "$(gitver)" = "$(upstreamver)" ]; then \
		dch -i --package pymvpa-snapshot ; \
	else \
		dch --newversion $(gitver)-1 --package pymvpa-snapshot \
			--allow-lower-version "PyMVPA development snapshot." ; \
	fi

## immediately useable documentation and exemplar scripts/data
override_dh_compress:
	dh_compress -X.py -X.html -X.pdf -X.css -X.jpg -X.txt -X.js -X.json -X.rtc -Xobjects.inv -X.ipynb

=== debian/watch ===
version=3
http://alioth.debian.org/frs/?group_id=30954 .*/pymvpa_([\d\.]+)\.tar\.gz

## pymvpa2 2.3.1

=== Makefile ===
--- 
+++ 
@@ -140,6 +140,7 @@
 # clean docs
 	$(MAKE) -C doc clean
 	-@rm -f $(DOCSRC_DIR)/examples/*.rst
+	-@rm -f $(DOCSRC_DIR)/cmdline/*.rst
 # clean all bits and pieces
 	-@rm -f MANIFEST
 	-@rm -f mvpa2/clfs/lib*/*.so \
@@ -187,10 +188,20 @@
 	@echo "I: Creating manpages"
 	PYTHONPATH=$(LPYTHONPATH) help2man -N -n 'preprocess fMRI data for PyMVPA' \
 		bin/pymvpa2-prep-fmri > $(MAN_DIR)/pymvpa2-prep-fmri.1
-	PYTHONPATH=$(LPYTHONPATH) help2man -N -n 'query stereotaxic atlases' \
-		bin/pymvpa2-atlaslabeler > $(MAN_DIR)/pymvpa2-atlaslabeler.1
 	PYTHONPATH=$(LPYTHONPATH) help2man -N -n 'start a PyMVPA tutorial session' \
 		bin/pymvpa2-tutorial > $(MAN_DIR)/pymvpa2-tutorial.1
+	PYTHONPATH=$(LPYTHONPATH) help2man --no-discard-stderr -N -n \
+			'preprocess FreeSurfer surfaces for AFNI/SUMA' \
+			bin/pymvpa2-prep-afni-surf > $(MAN_DIR)/pymvpa2-prep-afni-surf.1
+	PYTHONPATH=$(LPYTHONPATH) help2man --no-discard-stderr \
+		--help-option="--help-np" -N -n "command line interface for PyMVPA" \
+			bin/pymvpa2 > $(MAN_DIR)/pymvpa2.1
+	for cmd in $$(tr "\n'," ' ' < bin/pymvpa2 | sed -e 's/.*enabled_cmds = \[//' -e 's/\].*//'); do \
+		summary="$$(grep 'man: -*-' < mvpa2/cmdline/cmd_$${cmd}.py | cut -d '%' -f 2-)"; \
+		PYTHONPATH=$(LPYTHONPATH) help2man --no-discard-stderr \
+			--help-option="--help-np" -N -n "$$summary" \
+				"bin/pymvpa2 $${cmd}" > $(MAN_DIR)/pymvpa2-$${cmd}.1 ; \
+	done
 
 references:
 	@echo "I: Generating references"
@@ -201,7 +212,7 @@
 	echo "backend : Agg" >| $(CURDIR)/build/matplotlibrc
 	touch $@
 
-htmldoc: examples2rst build pics mpl-stamp tutorial2notebooks
+htmldoc: examples2rst build pics mpl-stamp notebooks manpages
 	@echo "I: Creating an HTML version of documentation"
 	cd $(DOC_DIR) && MVPA_EXTERNALS_RAISE_EXCEPTION=off \
 		PYTHONPATH=$(CURDIR):$(PYTHONPATH) \
@@ -212,6 +223,7 @@
 	cd $(HTML_DIR)/workshops && ln -sf ../_static
 	cd $(HTML_DIR)/datadb && ln -sf ../_static
 	cp $(DOCSRC_DIR)/pics/history_splash.png $(HTML_DIR)/_images/
+	cp $(DOC_DIR)/pics/*-logo_h*.png $(HTML_DIR)/_static/
 
 pdfdoc: examples2rst build pics pdfdoc-stamp
 pdfdoc-stamp: mpl-stamp
@@ -237,10 +249,14 @@
 		--outdir $(DOCSRC_DIR)/examples \
 		--exclude doc/examples/searchlight_app.py \
 		doc/examples
-	touch $@
-
-tutorial2notebooks: tutorial2notebooks-stamp
-tutorial2notebooks-stamp:
+	tools/cmdex2rst \
+		--project PyMVPA \
+		--outdir $(DOCSRC_DIR)/cmdline/ \
+		doc/examples/cmdline
+	touch $@
+
+notebooks: notebooks-stamp
+notebooks-stamp: examples2rst
 	mkdir -p $(NOTEBOOKBUILD_DIR)
 	tools/rst2ipnbpy \
 		--baseurl http://pymvpa.org \
@@ -248,8 +264,9 @@
 		--glossary_baseurl http://pymvpa.org/glossary.html \
 		--outdir $(NOTEBOOKBUILD_DIR) \
 		--exclude doc/source/tutorial_prerequisites.rst \
+		--exclude doc/source/examples/searchlight_surf.rst \
 		--verbose \
-		doc/source/tutorial_*.rst
+		doc/source/tutorial_*.rst doc/source/examples/*.rst
 	touch $@
 
 apidoc: apidoc-stamp
@@ -352,24 +369,3 @@
 	@cd $(TEST_DIR) && PYTHONPATH=mvpa2/tests/badexternals:$(LPYTHONPATH) \
 		MVPA_MATPLOTLIB_BACKEND=agg \
 		$(PYTHON) mvpa2/tests/__init__.py 2>&1 \
-		| grep -v -e 'WARNING: Known dependency' -e 'Please note: w' \
-		          -e 'WARNING:.*SMLR.* implementation'
-
-# only non-labile tests
-unittest-nonlabile: build
-	@echo "I: Running only non labile unittests. None of them should ever fail."
-	@cd $(TEST_DIR) && MVPA_TESTS_LABILE=no \
-		$(MPLPYTHON) mvpa2/tests/__init__.py
-
-unittest-py3: build3
-	@echo "I: Running py3-compatible unittests. None of them should ever fail."
-	-@rm -f build3-stamp	# evil Tiziano! ;)
-	@cd $(BUILD3DIR) && MVPA_TESTS_LABILE=no MVPA_TESTS_QUICK=yes \
-		MVPA_TESTS_LOWMEM=yes $(MPLPYTHON3) mvpa2/tests/__init__.py
-
-unittest-py3warn: build
-	@echo "I: Running unittests with py3 warnings. None of them should ever fail."
-	@MVPA_TESTS_LABILE=no MVPA_TESTS_QUICK=yes \
-		MVPA_TESTS_LOWMEM=yes $(MPLPYTHON) -3 mvpa2/tests/__init__.py
-
-

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
PYTHON        = python
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest

export SHELL=/bin/bash

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  dirhtml   to make HTML files named index.html in directories"
	@echo "  pickle    to make pickle files"
	@echo "  json      to make JSON files"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  qthelp    to make HTML files and a qthelp project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  changes   to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  doctest   to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR) source/generated
	-rm generate-stamp

SPHINXEXT_PATH=$(shell python -c 'import sphinx.ext; from distutils.version import LooseVersion; print LooseVersion(sphinx.__version__) < "1.1.2" and "sphinxext" or sphinx.ext.__path__[0]')
#SPHINXEXT_PATH=sphinxext

generate: generate-stamp
generate-stamp:
	mkdir -p $(BUILDDIR)
	@MVPA_EXTERNALS_RAISE_EXCEPTION=off \
		PYTHONPATH=$(CURDIR)/sphinxext:$(CURDIR)/..:$(PYTHONPATH) \
		$(PYTHON) $(SPHINXEXT_PATH)/autosummary/generate.py \
		-t $(CURDIR)/templates -o source/generated source/*.rst
	# wipe everything that is not pymvpa to prevent suffering from the bugs
	# of other in subsequent stages
	find source/generated -type f ! -name 'mvpa*' -delete
	set -e; set -o pipefail; for man in $(BUILDDIR)/man/pymvpa*; do \
		manfile=$$(basename $${man}) ; \
		cmd=$${manfile#pymvpa2-*} ; \
		cmd=$${cmd%*.1} ; \
		man2html $${man} | sed -n '/<HR>/{:a;n;/<HR>/b;p;ba}' | sed -n '/<A NAME/{:a;n;/This document was created by/b;p;ba}' > source/generated/$${manfile}.html ; \
		underline="*****************$$(echo $${cmd} | tr A-Za-z0-9 \*)" ; \
		echo ".. index:: command line, $${cmd}\n.. _chap_cmdline_$${cmd}\n\n$${underline}\nMan page for \`\`$${cmd}\`\`\n$${underline}\n\n.. raw:: html\n   :file: $${manfile}.html\n" > source/generated/cmd_$${cmd}.rst ; \
	done
	@touch $@

html: generate
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml: generate
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

pickle: generate
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json: generate
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp: generate
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp: generate
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/PyMVPA.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/PyMVPA.qhc"

latex: generate
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

changes: generate
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck: generate
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest: generate
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== doc/pics/Makefile ===
all:: pymvpa_logo.jpg download_icon.jpg tutorial_icon.jpg \
      documentation_icon.jpg support_icon.jpg movie_icon.jpg \
      pymvpa_icon.jpg \
      pics

# where the rendered images should go
TARGETDIR = ../source/pics
STATICDIR = ../source/_static

# special case of icon svg
ICON_SVG_BASE = pymvpa_icons
ICON_HEIGHT = $(shell inkscape -z -f $(ICON_SVG_BASE).svg -H)
ICON_WIDTH = $(shell inkscape -z -f $(ICON_SVG_BASE).svg -W)
ICON_NUMBER = 6

LOGO_HEIGHT = 70

# PICS_IGNORE must contain a rule for grep
PICS_IGNORE ?= "$(ICON_SVG_BASE)"

# For every .svg we must have a pdf
PDFPICS=$(shell find . -iname \*svg \
	| sed -e 's/svg$$/pdf/g' -e 's/\([^\]\)\([ \t:]\)/\1\\\\\2/g' \
	| grep -v -e $(PICS_IGNORE) )
# and a png
PNGPICS=$(shell find . -iname \*svg \
	| sed -e 's/svg$$/png/g' -e 's/\([^\]\)\([ \t:]\)/\1\\\\\2/g' \
	| grep -v -e $(PICS_IGNORE) )
LOGOPICS=ccn-logo_h$(LOGO_HEIGHT).png uni-md-logo_h$(LOGO_HEIGHT).png dartmouth-logo_h$(LOGO_HEIGHT).png

pics: $(PDFPICS) $(PNGPICS) $(LOGOPICS)

clean::
	for p in *.svg; do \
		rm -f $(TARGETDIR)/$${p%*.svg}.pdf; \
		rm -f $(TARGETDIR)/$${p%*.svg}.png; \
		rm -f $(TARGETDIR)/$${p%*.svg}.jpg; \
	done
	for p in *.svg; do \
		rm -f $${p%*.svg}.pdf; \
		rm -f $${p%*.svg}.png; \
		rm -f $${p%*.svg}.jpg; \
		rm -f $(STATICDIR)/$${p%*.svg}.jpg; \
	done
	-rm -f $(STATICDIR)/*_icon.jpg *_icon.*

.PHONY: ignore-%
ignore-%:
	@grep -q "^$*$$" $(TARGETDIR)/.gitignore || { \
	  echo "$*" >> $(TARGETDIR)/.gitignore; echo "Ignore $*"; }
	@grep -q "^$*$$" $(STATICDIR)/.gitignore || { \
	  echo "$*" >> $(STATICDIR)/.gitignore; echo "Ignore $*"; }
	@grep -q "^$*$$" .gitignore || { echo "$*" >> .gitignore; }

#
# Inkscape rendered figures
#
%.pdf: %.svg ignore-%.pdf
	@echo "Rendering $@"
	@inkscape -z -f "$<" -A "$@" --export-dpi=300
	@cp "$@" $(TARGETDIR)

%.png: %.svg ignore-%.png
	@echo "Rendering $@"
	@inkscape -z -f "$<" -e "$@" --export-width=500
	@cp "$@" $(TARGETDIR)

%.jpg: %.png ignore-%.jpg
	@echo "Converting $*.png to $*.jpg"
	@convert -flatten -resize x130 $*.png $*.jpg
	@cp "$@" $(STATICDIR)

# logo sized versions
%_h70.png: %.png ignore-%_h70.png
	@echo "Generating downscaled $@"
	@convert -geometry x70 "$<" "$@"

# special cases
download_icon.png: $(ICON_SVG_BASE).svg
	inkscape -z -f $(ICON_SVG_BASE).svg -e $@ \
		--export-area=$(shell echo "$(ICON_WIDTH) / $(ICON_NUMBER) * 0" | bc):0:$(shell echo "$(ICON_WIDTH) / $(ICON_NUMBER) * 1" | bc):$(ICON_HEIGHT)
	$(MAKE) ignore-$@

tutorial_icon.png: $(ICON_SVG_BASE).svg
	inkscape -z -f $(ICON_SVG_BASE).svg -e $@ \
		--export-area=$(shell echo "$(ICON_WIDTH) / $(ICON_NUMBER) * 1" | bc):0:$(shell echo "$(ICON_WIDTH) / $(ICON_NUMBER) * 2" | bc):$(ICON_HEIGHT)
	$(MAKE) ignore-$@

documentation_icon.png: $(ICON_SVG_BASE).svg
	inkscape -z -f $(ICON_SVG_BASE).svg -e $@ \
		--export-area=$(shell echo "$(ICON_WIDTH) / $(ICON_NUMBER) * 2" | bc):0:$(shell echo "$(ICON_WIDTH) / $(ICON_NUMBER) * 3" | bc):$(ICON_HEIGHT)
	$(MAKE) ignore-$@

support_icon.png: $(ICON_SVG_BASE).svg
	inkscape -z -f $(ICON_SVG_BASE).svg -e $@ \
		--export-area=$(shell echo "$(ICON_WIDTH) / $(ICON_NUMBER) * 3" | bc):0:$(shell echo "$(ICON_WIDTH) / $(ICON_NUMBER) * 4" | bc):$(ICON_HEIGHT)
	$(MAKE) ignore-$@

movie_icon.png: $(ICON_SVG_BASE).svg
	inkscape -z -f $(ICON_SVG_BASE).svg -e $@ \
		--export-area=$(shell echo "$(ICON_WIDTH) / $(ICON_NUMBER) * 4" | bc):0:$(shell echo "$(ICON_WIDTH) / $(ICON_NUMBER) * 5" | bc):$(ICON_HEIGHT)
	$(MAKE) ignore-$@

pymvpa_icon.png: $(ICON_SVG_BASE).svg
	inkscape -z -f $(ICON_SVG_BASE).svg -e $@ \
		--export-area=$(shell echo "$(ICON_WIDTH) / $(ICON_NUMBER) * 5" | bc):$(shell echo "$(ICON_HEIGHT) * 0.463/4.211" | bc):$(shell echo "$(ICON_WIDTH) / $(ICON_NUMBER) * 6" | bc):$(ICON_HEIGHT)
	$(MAKE) ignore-$@

.PHONY: all pics

=== debian/changelog ===
pymvpa2 (2.3.1-2) unstable; urgency=medium

  * debian/patches
    - changeset_f12e1c41b7cf6b59b686c8f78d55ffba1eced8e1.diff
      + debian/rules changes to cache intersphinx mappings under
      debian/intersphinx (Closes: #765300).  Thanks Sandro Tosi
      for the report and pointers to the resolution
    - changeset_5f62f33a7d84dca01c2aae69a4d4c0a00469ae7b.diff
      to fix up url to the h5py intersphinx
  * debian/upstream -> debian/upstream/metadata
  * debian/patches
    - deb_no_twitter_privacy_breach -- just refer to twitter instead

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 28 Oct 2014 11:56:59 -0400

pymvpa2 (2.3.1-1) unstable; urgency=medium

  * Fresh upstream release (should be tollerant now to scipy API change in
    1.4.0)
  * debian/watch
    - adjusted to monitor/fetch from github tags
  * debian/patches
    - all removed
  * debian/{control,rules}
    - use dh_python2 instead of deprecated pysupport
    - add matplotlib to build-depends and set its backend to Agg during
      testing

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 20 May 2014 08:43:24 -0400

pymvpa2 (2.3.0-3) unstable; urgency=low

  * debian/control
    - man2html to build-depends
  * debian/patches
    - 2.3.0-37-g269c43c.diff to resolve FTBFS on trusty

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 01 May 2014 14:23:56 -0400

pymvpa2 (2.3.0-1) unstable; urgency=low

  * Perspective fresh upstream release
    - contains all patches from under debian/patches/ so those are dropped
  * debian/control
    - recommend python-nipy
  * debian/rules
    - do not compress .sh scripts (cmdline examples)

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 05 Mar 2014 23:00:31 +0100

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,21 @@
 Source: pymvpa2
 Section: python
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: NeuroDebian team <team@neuro.debian.net>
+Maintainer: NeuroDebian team <team@neuro.debian.net>
 Uploaders: Michael Hanke <mih@debian.org>, Yaroslav Halchenko <debian@onerussian.com>
 Build-Depends: debhelper (>= 7.0.50~),
-               python-all-dev (>= 2.4), python-support (>= 0.6), swig,
+               python-all-dev (>= 2.6.6-3~),
+               swig,
                python-numpy, python-scipy,
                python-nibabel,
                python-nose,
                python-h5py,
                python-lxml,
                libsvm-dev (>= 2.84.0),
-               help2man,
+               help2man, man2html,
                python-sphinx, python-numpydoc,
                graphviz, inkscape, imagemagick, bc,
+               python-matplotlib,
 Standards-Version: 3.9.5
 Homepage: http://www.pymvpa.org
 Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/pymvpa.git
@@ -33,6 +34,7 @@
          python-matplotlib,
          python-mdp,
          python-nibabel,
+         python-nipy,
          python-psutil,
          python-psyco,
          python-pywt,

=== debian/rules ===
--- 
+++ 
@@ -16,19 +16,21 @@
 # one ring to rule them all ...
 %:
 # need to enforce distutils, since we also have a makefile
-	dh $@ --buildsystem=python_distutils --builddirectory=build
+	dh $@ --with=python2 --buildsystem=python_distutils --builddirectory=build
 
 override_dh_auto_configure:
 	dh_auto_configure
 	mkdir -p $(CURDIR)/build
+	cp -rp debian/intersphinx doc/source/
 
 override_dh_auto_build:
 	dh_auto_build -- --with-libsvm
 	$(MAKE) manpages
 ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
-	$(MAKE) htmldoc
+	http_proxy=http://127.0.0.1:9/ https_proxy=http://127.0.0.1:9/ \
+		$(MAKE) htmldoc
 	-rm build/html/_static/jquery.js build/html/_static/underscore.js
-	$(MAKE) tutorial2notebooks
+	$(MAKE) notebooks
 endif
 
 
@@ -46,7 +48,7 @@
 		echo "I: Running PyMVPA unittests using python$$buildver"; \
 		cd $(CURDIR)/debian/tmp/usr/lib/python$$buildver/*-packages && \
 		PYTHONPATH=. MVPA_TESTS_LABILE=no MVPA_TESTS_LOWMEM=yes \
-		MVPA_TESTS_QUICK=yes MVPA_TESTS_VERBOSITY=3 \
+		MVPA_TESTS_QUICK=yes MVPA_TESTS_VERBOSITY=3 MVPA_MATPLOTLIB_BACKEND=agg \
 		python$$buildver mvpa2/tests/__init__.py \
 		|| exit 1 ; find . -type f -name '*.pyc' -delete ; \
 	done
@@ -64,8 +66,8 @@
 	| grep -e 'pymvpa2-\(analysis\)' \
 	| xargs -r rm -rf
 
-override_dh_pysupport:
-	dh_pysupport
+override_dh_python2:
+	dh_python2
 	if [ -x /usr/bin/dh_numpy ]; then dh_numpy; fi
 
 override_dh_installchangelogs:
@@ -102,4 +104,10 @@
 
 ## immediately useable documentation and exemplar scripts/data
 override_dh_compress:
-	dh_compress -X.py -X.html -X.pdf -X.css -X.jpg -X.txt -X.js -X.json -X.rtc -Xobjects.inv -X.ipynb
+	dh_compress -X.py -X.html -X.pdf -X.css -X.jpg -X.txt -X.js -X.json -X.rtc -Xobjects.inv -X.ipynb -X.sh
+
+cache_intersphinx:
+	rm -rf debian/intersphinx
+	-rm doc/cache_intersphinx-stamp
+	make -C doc cache_intersphinx
+	mv doc/source/intersphinx debian/

## pymvpa2 2.4.0

=== Makefile ===
--- 
+++ 
@@ -259,7 +259,7 @@
 notebooks-stamp: examples2rst
 	mkdir -p $(NOTEBOOKBUILD_DIR)
 	tools/rst2ipnbpy \
-		--baseurl http://pymvpa.org \
+		--baseurl http://pymvpa.org/examples \
 		--apiref_baseurl http://pymvpa.org/generated \
 		--glossary_baseurl http://pymvpa.org/glossary.html \
 		--outdir $(NOTEBOOKBUILD_DIR) \
@@ -368,4 +368,3 @@
 	@echo "I: Running unittests under assumption of missing optional externals."
 	@cd $(TEST_DIR) && PYTHONPATH=mvpa2/tests/badexternals:$(LPYTHONPATH) \
 		MVPA_MATPLOTLIB_BACKEND=agg \
-		$(PYTHON) mvpa2/tests/__init__.py 2>&1 \

=== debian/changelog ===
pymvpa2 (2.4.0-1) unstable; urgency=medium

  * New upstream yet to be released release
    - drop support of Python 2.6
  * debian/control
    - boosted policy to 3.9.6
    - added statsmodels to build-depends and recommends, joblib to recommends
    - recommend python-shogun instead of dated shogun-python-modular

 -- Yaroslav Halchenko <debian@onerussian.com>  Sun, 10 May 2015 22:06:33 +0100

=== debian/control ===
--- 
+++ 
@@ -16,11 +16,12 @@
                python-sphinx, python-numpydoc,
                graphviz, inkscape, imagemagick, bc,
                python-matplotlib,
-Standards-Version: 3.9.5
+               python-statsmodels,
+Standards-Version: 3.9.6
 Homepage: http://www.pymvpa.org
 Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/pymvpa.git
 Vcs-Git: git://git.debian.org/git/pkg-exppsy/pymvpa.git -b dist2/debian/proper/sid
-X-Python-Version: >= 2.6
+X-Python-Version: >= 2.7
 
 
 Package: python-mvpa2
@@ -41,9 +42,11 @@
          python-reportlab,
          python-scipy,
          python-sklearn,
-         shogun-python-modular,
+         python-shogun,
          liblapack-dev,
          python-pprocess,
+         python-statsmodels,
+         python-joblib,
 Suggests:
          fslview, fsl,
          python-mvpa2-doc,

=== debian/rules ===
--- 
+++ 
@@ -109,5 +109,6 @@
 cache_intersphinx:
 	rm -rf debian/intersphinx
 	-rm doc/cache_intersphinx-stamp
-	make -C doc cache_intersphinx
+	make
+	PYTHONPATH=$(CURDIR) make -C doc cache_intersphinx
 	mv doc/source/intersphinx debian/

## pymvpa2 2.4.1

=== Makefile ===
--- 
+++ 
@@ -264,7 +264,6 @@
 		--glossary_baseurl http://pymvpa.org/glossary.html \
 		--outdir $(NOTEBOOKBUILD_DIR) \
 		--exclude doc/source/tutorial_prerequisites.rst \
-		--exclude doc/source/examples/searchlight_surf.rst \
 		--verbose \
 		doc/source/tutorial_*.rst doc/source/examples/*.rst
 	touch $@
@@ -368,3 +367,4 @@
 	@echo "I: Running unittests under assumption of missing optional externals."
 	@cd $(TEST_DIR) && PYTHONPATH=mvpa2/tests/badexternals:$(LPYTHONPATH) \
 		MVPA_MATPLOTLIB_BACKEND=agg \
+		$(PYTHON) mvpa2/tests/__init__.py 2>&1 \

=== requirements.txt ===
# should be present but installing via pip might be too lengthy
# numpy
# scipy
# sklearn
duecredit
nibabel
# not compatible ATM with python3
# pprocess

=== debian/changelog ===
pymvpa2 (2.4.1-1) unstable; urgency=medium

  * Fresh upstream release
  * debian/{control,rules}
    - Use swig2.0 (or swig3.0 < 3.0.5).
      See https://github.com/swig/swig/issues/563

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 18 Nov 2015 13:24:34 -0500

pymvpa2 (2.4.0.1-1) unstable; urgency=medium

  * Upstream snapshot release
    - addresses compatibility issue with recent scipy
  * debian/patches/0001-BF-allow-to-compare-SmartVersion-None.patch
    - CPed from PR to resolve failing test whenever IPython is N/A

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 21 Oct 2015 11:46:49 -0500

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Michael Hanke <mih@debian.org>, Yaroslav Halchenko <debian@onerussian.com>
 Build-Depends: debhelper (>= 7.0.50~),
                python-all-dev (>= 2.6.6-3~),
-               swig,
+               swig2.0 | swig (< 3.0.5),
                python-numpy, python-scipy,
                python-nibabel,
                python-nose,
@@ -17,6 +17,7 @@
                graphviz, inkscape, imagemagick, bc,
                python-matplotlib,
                python-statsmodels,
+Build-Conflicts: swig3.0 (>= 3.0.5),
 Standards-Version: 3.9.6
 Homepage: http://www.pymvpa.org
 Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/pymvpa.git

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,8 @@
 gitver = $(shell [ -x /usr/bin/git ] && git describe --tags --match 'upstream/*' $$(git merge-base -a HEAD master) | sed -e 's,^upstream/,,' -e 's/\.dev/~dev/' -e 's/\.rc/~rc/')
 
 export HOME=$(CURDIR)/build
+# so we could use custom symlinked swig2.0
+export PATH:=$(PATH):$(HOME)
 
 # one ring to rule them all ...
 %:
@@ -22,6 +24,7 @@
 	dh_auto_configure
 	mkdir -p $(CURDIR)/build
 	cp -rp debian/intersphinx doc/source/
+	which swig >/dev/null || ln -s /usr/bin/swig2.0 $(CURDIR)/build/swig
 
 override_dh_auto_build:
 	dh_auto_build -- --with-libsvm

## pymvpa2 2.5.0

=== Makefile ===
--- 
+++ 
@@ -16,8 +16,14 @@
 SWARM_DIR=$(BUILDDIR)/swarm
 WWW_UPLOAD_URI=www.pymvpa.org:/home/www/www.pymvpa.org/pymvpa
 WWW_UPLOAD_URI_DEV=dev.pymvpa.org:/home/www/dev.pymvpa.org/pymvpa
-DATA_UPLOAD_URI=data.pymvpa.org:/home/www/data.pymvpa.org/www/datasets
-DATA_URI=data.pymvpa.org::datadb
+DATA_HOST=data.pymvpa.org
+DATA_DIR=datadb
+DATA_SUBDIRS='$(DATA_DIR)/tutorial_data \
+                  $(DATA_DIR)/mnist \
+                  $(DATA_DIR)/face_inversion_demo \
+                  $(DATA_DIR)/hyperalignment_tutorial_data \
+                  $(DATA_DIR)/haxby2001'
+DATA_UPLOAD_URI=$(DATA_HOST):/home/www/data.pymvpa.org/www/datasets
 SWARMTOOL_DIR=tools/codeswarm
 SWARMTOOL_DIRFULL=$(CURDIR)/$(SWARMTOOL_DIR)
 RSYNC_OPTS=-az -H --no-perms --no-owner --verbose --progress --no-g --exclude prev/
@@ -364,7 +370,3 @@
 
 # test if PyMVPA is working if optional externals are missing
 unittest-badexternals: build
-	@echo "I: Running unittests under assumption of missing optional externals."
-	@cd $(TEST_DIR) && PYTHONPATH=mvpa2/tests/badexternals:$(LPYTHONPATH) \
-		MVPA_MATPLOTLIB_BACKEND=agg \
-		$(PYTHON) mvpa2/tests/__init__.py 2>&1 \

=== debian/changelog ===
pymvpa2 (2.5.0-2) unstable; urgency=medium

  * debian/control
    - swap order of swig2.0 and swig in build-depends to please buildds
      (Closes: #830394)

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 08 Jul 2016 09:33:17 -0400

pymvpa2 (2.5.0-1) unstable; urgency=medium

  * Fresh upstream feature release

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 11 May 2016 16:55:18 -0400

pymvpa2 (2.4.3-1) unstable; urgency=medium

  * debian/control
    - recommends python-duecredit
    - do not require (absent atm) optional statsmodels on s390x

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 14 Mar 2016 20:59:58 -0400

pymvpa2 (2.4.2-1) unstable; urgency=medium

  * Fresh upstream release
    - compatible with swig 3 (Closes: #817000)
  * debian/control
    - boosted policy to 3.9.7
    - relaxed build-depends

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 07 Mar 2016 20:35:31 -0500

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Michael Hanke <mih@debian.org>, Yaroslav Halchenko <debian@onerussian.com>
 Build-Depends: debhelper (>= 7.0.50~),
                python-all-dev (>= 2.6.6-3~),
-               swig2.0 | swig (< 3.0.5),
+               swig | swig2.0,
                python-numpy, python-scipy,
                python-nibabel,
                python-nose,
@@ -16,9 +16,9 @@
                python-sphinx, python-numpydoc,
                graphviz, inkscape, imagemagick, bc,
                python-matplotlib,
-               python-statsmodels,
-Build-Conflicts: swig3.0 (>= 3.0.5),
-Standards-Version: 3.9.6
+               python-statsmodels [!s390x],
+               python-joblib
+Standards-Version: 3.9.7
 Homepage: http://www.pymvpa.org
 Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/pymvpa.git
 Vcs-Git: git://git.debian.org/git/pkg-exppsy/pymvpa.git -b dist2/debian/proper/sid
@@ -48,6 +48,7 @@
          python-pprocess,
          python-statsmodels,
          python-joblib,
+         python-duecredit,
 Suggests:
          fslview, fsl,
          python-mvpa2-doc,
